// Generated by CoffeeScript 1.9.3
.pragma library;
"use strict";
var humanBytes, humanDatetime, humanSeconds, humanTimeElapse, padLeft;

humanBytes = function(bytes, fragDigits) {
  var giga, kilo, mega, tera;
  if (fragDigits == null) {
    fragDigits = 2;
  }
  kilo = Math.pow(2, 10);
  mega = Math.pow(2, 20);
  giga = Math.pow(2, 30);
  tera = Math.pow(2, 40);
  if (bytes >= tera) {
    return (bytes / tera).toFixed(fragDigits) + "TiB";
  } else if (bytes >= giga) {
    return (bytes / giga).toFixed(fragDigits) + "GiB";
  } else if (bytes >= mega) {
    return (bytes / mega).toFixed(fragDigits) + "MiB";
  } else {
    return (bytes / kilo).toFixed(fragDigits) + "KiB";
  }
};

padLeft = function(src, padder, len) {
  src = src + "";
  if (src.length <= len) {
    return (new Array(len - src.length + 1)).join(padder) + src;
  } else {
    return src;
  }
};

humanSeconds = function(seconds) {
  var hour, minute, second;
  if (seconds > 24 * 60 * 60 - 1) {
    return "--:--:--";
  }
  hour = (seconds / 3600) | 0;
  minute = ((seconds / 60) % 60) | 0;
  second = seconds % 60 | 0;
  return (padLeft(hour, '0', 2)) + ":" + (padLeft(minute, '0', 2)) + ":" + (padLeft(second, '0', 2));
};

humanDatetime = function(timestamp) {
  return new Date(timestamp * 1000).toString();
};

humanTimeElapse = function(timestamp) {
  var day, elapse, elapse_ms, hour, minute, month, year;
  elapse_ms = Date.now() - new Date(timestamp * 1000);
  elapse = (elapse_ms / 1000) | 0;
  year = elapse / (60 * 60 * 24 * 365) | 0;
  if (year) {
    return year + "年前";
  }
  month = elapse / (60 * 60 * 24 * 30) | 0;
  if (month) {
    return month + "月前";
  }
  day = elapse / (60 * 60 * 24) | 0;
  if (day) {
    return day + "天前";
  }
  hour = elapse / (60 * 60) | 0;
  if (hour) {
    return hour + "小时前";
  }
  minute = elapse / 60 | 0;
  if (minute) {
    return minute + "分钟前";
  }
  return "刚才";
};
