// Generated by CoffeeScript 1.9.3
"use strict";
var LoginHelper,
  bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

LoginHelper = (function() {
  function LoginHelper() {
    this.bindSaveCredentials = bind(this.bindSaveCredentials, this);
    var intervalId;
    xdpy.sigLogin.connect(this, this.slotLogin);
    intervalId = setInterval((function(_this) {
      return function() {
        _this.$username = document.getElementById("al_u");
        _this.$password = document.getElementById("al_p");
        _this.$autologin = document.getElementById("al_remember");
        _this.$login = document.getElementById("al_submit");
        if (!(_this.$username && _this.$password && _this.$autologin && _this.$login)) {
          return console.log("Cannot find username/password/autologin/login, retry in 1 sec.");
        } else {
          xdpy.xdjsLoaded({
            peerids: [],
            userid: null
          });
          _this.bindSaveCredentials();
          return clearInterval(intervalId);
        }
      };
    })(this), 1000);
  }

  LoginHelper.prototype.slotLogin = function(username, password) {
    var interval_id;
    this.$username.value = username;
    this.$password.value = password;
    return interval_id = setInterval((function(_this) {
      return function() {
        var eventObj;
        eventObj = document.createEvent("MouseEvents");
        eventObj.initEvent("click", true, false);
        _this.$login.dispatchEvent(eventObj);
        return clearInterval(interval_id);
      };
    })(this), 1000);
  };

  LoginHelper.prototype.bindSaveCredentials = function() {
    return this.$login.addEventListener("click", (function(_this) {
      return function() {
        var autologin, password, username;
        autologin = _this.$autologin.checked;
        if (!autologin) {
          return;
        }
        username = _this.$username.value;
        password = _this.$password.value;
        return xdpy.saveCredentials(username, password);
      };
    })(this));
  };

  return LoginHelper;

})();

window.onerror = function(event, source, lineno, colno, error) {
  xdpy.onJsError(event, source, lineno, colno, error);
  return false;
};

document.onreadystatechange = function() {
  if (document.readyState === "complete") {
    return window.loginHelper = new LoginHelper();
  }
};

document.onreadystatechange();

null;
