// Generated by CoffeeScript 1.9.3
"use strict";
var XwareJS,
  slice = [].slice,
  indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

XwareJS = (function() {
  function XwareJS() {
    var peerid, result;
    xdpy.sigCreateTask.connect(this, this.slotCreateTask);
    xdpy.sigCreateTaskFromTorrentFile.connect(this, this.slotCreateTaskFromTorrentFile);
    xdpy.sigCreateTaskFromTorrentFileDone.connect(this, this.slotCreateTaskFromTorrentFileDone);
    xdpy.sigActivateDevice.connect(this, this.slotActivateDevice);
    xdpy.sigToggleFlashAvailability.connect(this, this.slotToggleFlashAvailability);
    this.boundPeerId = false;
    xdpy.sigNotifyPeerId.connect(this, this.slotWaitToBindDeviceObserver);
    this.bindDblclick();
    this.bindContextMenu();
    this.bindMaskObserver();
    this.bindTaskTabObserver();
    this.fixDeviceShortName();
    result = {};
    if (typeof Data !== "undefined" && Data !== null) {
      result.peerids = (function() {
        var results;
        results = [];
        for (peerid in Data.downloader.all) {
          results.push(peerid);
        }
        return results;
      })();
      result.userid = Data.session.userId;
    } else {
      result.peerids = [];
      result.userid = null;
    }
    xdpy.xdjsLoaded(result);
  }

  XwareJS.prototype.log = function() {
    var items;
    items = 1 <= arguments.length ? slice.call(arguments, 0) : [];
    return xdpy.log(items);
  };

  XwareJS.prototype.isShowingLocalDevice = function() {
    return this.boundPeerId === Data.downloader.pid;
  };

  XwareJS.prototype.bindDblclick = function() {
    var _this;
    _this = this;
    return $("#task-list").on("dblclick", "div.rw_unit", function(event) {
      var task, tid;
      if (!_this.isShowingLocalDevice()) {
        return;
      }
      tid = $(this).attr("data-tid");
      task = Data.task.all[tid];
      if (task.stateText === "已完成") {
        if (task.path) {
          xdpy.systemOpen(task.path + task.name);
        } else {
          console.error("No Task Path");
        }
        event.preventDefault();
        event.stopImmediatePropagation();
        return event.stopPropagation();
      }
    });
  };

  XwareJS.prototype.bindContextMenu = function() {
    var _this;
    _this = this;
    return $("#task-list").on("contextmenu", "div.rw_unit", function(event) {
      var $cmenu, $open, $openDir, task, tid;
      if (!_this.isShowingLocalDevice()) {
        return;
      }
      tid = $(this).attr("data-tid");
      task = Data.task.all[tid];
      $openDir = $("<li><a href='javascript:void(0)'>在文件夹中显示</a></li>");
      $openDir.on("click", function() {
        if (task.path) {
          return xdpy.systemViewOneFile(task.path + task.name);
        } else {
          return console.error("No Task Path");
        }
      });
      $cmenu = $("div#cmenu.flo_wrap > ul.flo_ul");
      $cmenu.prepend($openDir);
      if (task.stateText === "已完成") {
        $open = $("<li><a href='javascript:void(0)'>打开</a></li>");
        $open.on("click", function() {
          if (task.path) {
            return xdpy.systemOpen(task.path + task.name);
          } else {
            return console.error("No Task Path");
          }
        });
        return $cmenu.prepend($open);
      }
    });
  };

  XwareJS.prototype.slotCreateTask = function(task) {
    var $createTaskUrl;
    App.set("dialogs.createTask.show", true);
    $createTaskUrl = $("#d-create-task-url");
    $createTaskUrl.val(task);
    $createTaskUrl.keyup();
    $createTaskUrl.get(0).focus();
    return xdpy.requestFocus();
  };

  XwareJS.prototype.slotCreateTaskFromTorrentFile = function() {
    var $inputFile;
    App.set("dialogs.createTask.show", true);
    $(".faked").addClass("faked-toggle").removeClass("faked");
    $inputFile = $("#d-create-task-bt-file");
    $inputFile.focus();
    return xdpy.slotClickBtButton();
  };

  XwareJS.prototype.slotCreateTaskFromTorrentFileDone = function() {
    return $(".faked-toggle").remove("faked-toggle").addClass("faked");
  };

  XwareJS.prototype.slotToggleFlashAvailability = function(available) {
    return App.set("system.flash", available);
  };

  XwareJS.prototype.slotActivateDevice = function(code) {
    var $activateBtn, $panel, $types, input;
    App.set("dialogs.addDownloader.show", true);
    $types = $("#d-add-downloader-types > li");
    $("> a[title$='NAS']", $types).click();
    $types.not(":has(a[title$='NAS'])").hide();
    $panel = $("#d-add-downloader-panels > div.pop_addd_unit:not(.hidden)");
    $("> p", $panel).html("您需要激活后使用Xware Desktop。<br />激活码已经试着自动为您获取并填写，点击激活后稍等片刻即可。");
    input = $("input.sel_inptxt", $panel).get(0);
    $(input).val(code).blur().trigger('input');
    input.focus();
    $activateBtn = $(".btn_inp", $panel);
    return $activateBtn.on("click", function() {
      return setTimeout(function() {
        return location.reload(true);
      }, 5000);
    });
  };

  XwareJS.prototype.bindMaskObserver = function() {
    var mask, maskon, observer;
    mask = document.getElementById("mask");
    maskon = false;
    if (!mask) {
      return;
    }
    xdpy.slotMaskOnOffChanged(false);
    observer = new MutationObserver(function() {
      var maskon_new;
      maskon_new = indexOf.call(mask.classList, "hidden") < 0;
      if (maskon_new !== maskon) {
        maskon = maskon_new;
        return xdpy.slotMaskOnOffChanged(maskon);
      }
    });
    return observer.observe(mask, {
      "childList": false,
      "attributes": true,
      "characterData": false,
      "subtree": false,
      "attributeOldValue": false,
      "characterDataOldValue": false,
      "attributeFilter": ["class"]
    });
  };

  XwareJS.prototype.getDeviceIndex = function(peerId) {
    var i, item, ref;
    ref = Data.downloader.list;
    for (i in ref) {
      item = ref[i];
      if (item.pid === peerId) {
        return i;
      }
    }
    return NaN;
  };

  XwareJS.prototype.bindDeviceObserver = function(boundPeerId) {
    var _logined, _online, deviceIndex;
    if (this.boundPeerId) {
      return;
    }
    this.boundPeerId = boundPeerId;
    deviceIndex = this.getDeviceIndex(boundPeerId);
    if ((!isNaN(deviceIndex)) && (App.get("downloader.activedIndex") !== deviceIndex)) {
      App.set("downloader.activedIndex", deviceIndex);
    }
    this.log("bindDeviceObserver");
    _online = Data.downloader.all[boundPeerId].online;
    _logined = Data.downloader.all[boundPeerId].logined;
    Object.defineProperty(Data.downloader.all[boundPeerId], "online", {
      get: function() {
        return _online;
      },
      set: (function(_this) {
        return function(v) {
          _online = v;
          xdpy.slotSetOnline(v);
          return console.log("set online", v);
        };
      })(this)
    });
    Object.defineProperty(Data.downloader.all[boundPeerId], "logined", {
      get: function() {
        return _logined;
      },
      set: (function(_this) {
        return function(v) {
          _logined = v;
          xdpy.slotSetLogined(v);
          return console.log("set logined", v);
        };
      })(this)
    });
    if (typeof _online === "number") {
      xdpy.slotSetOnline(_online);
    }
    if (typeof _logined === "number") {
      return xdpy.slotSetLogined(_logined);
    }
  };

  XwareJS.prototype.slotWaitToBindDeviceObserver = function(boundPeerId) {
    var intervalId;
    if ((typeof Data !== "undefined" && Data !== null ? Data.downloader : void 0) != null) {
      return intervalId = setInterval((function(_this) {
        return function() {
          if (boundPeerId in Data.downloader.all) {
            clearInterval(intervalId);
            return _this.bindDeviceObserver(boundPeerId);
          }
        };
      })(this), 500);
    }
  };

  XwareJS.prototype.bindTaskTabObserver = function() {
    var observer, taskSidebar;
    taskSidebar = document.getElementById("task-sidebar");
    if (!taskSidebar) {
      return;
    }
    observer = new MutationObserver((function(_this) {
      return function(mutations) {
        return mutations.forEach(function(m) {
          if (indexOf.call(m.target.classList, "on") >= 0 && !m.oldValue) {
            return $("#task-list").attr("data-showtype", m.target.getAttribute("data-value"));
          }
        });
      };
    })(this));
    return observer.observe(taskSidebar, {
      "childList": false,
      "attributes": true,
      "characterData": false,
      "subtree": true,
      "attributeOldValue": true,
      "characterDataOldValue": false,
      "attributeFilter": ['class']
    });
  };

  XwareJS.prototype.fixDeviceShortName = function() {
    var ref;
    if ((typeof Data !== "undefined" && Data !== null ? (ref = Data.downloader) != null ? ref.template : void 0 : void 0) != null) {
      return Data.downloader.template.item = Data.downloader.template.item.replace(/\{\{shortName\}\}/g, "{{name}}");
    }
  };

  return XwareJS;

})();

$(function() {
  window.onerror = function(event, source, lineno, colno, error) {
    xdpy.onJsError(event, source, lineno, colno, error);
    return false;
  };
  if ((!window.MutationObserver) && window.WebKitMutationObserver) {
    window.MutationObserver = window.WebKitMutationObserver;
  }
  return window.xdjs = new XwareJS();
});

null;
